"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));

// src/index.ts
var require_src = __commonJS({
  "src/index.ts"(exports2, module2) {
    "use strict";
    var import_core = require("@babel/core");
    var import_complugin = require("complugin");
    var import_lodash = require("lodash");
    var compluginBabel2 = (0, import_complugin.createComplugin)({
      name: "babel",
      enforce: void 0,
      factory(options, meta) {
        let CWD = process.cwd();
        if (meta.framework === "esbuild") {
          CWD = meta.build.initialOptions.absWorkingDir ?? CWD;
        }
        const { include: _include = [/\.(tsx?|jsx?|mjs)$/i], exclude: _exclude, cwd, ..._babelOptions } = options ?? {};
        const babelOptions = {
          ..._babelOptions,
          code: true,
          sourceMaps: true,
          compact: false,
          cwd: cwd ?? CWD
        };
        const getTransformOptions = (0, import_lodash.once)(async () => {
          var _a;
          return (_a = await (0, import_core.loadPartialConfigAsync)(babelOptions)) == null ? void 0 : _a.options;
        });
        return {
          transformInclude: import_complugin.utils.createFilter(_include, _exclude),
          async transform(code, id) {
            const transformOptions = await getTransformOptions();
            const result = await (0, import_core.transformAsync)(code, { ...transformOptions, filename: id });
            if (result) {
              const { code: code2, map } = result;
              if (code2 != null) {
                return { code: code2, map };
              }
            }
          }
        };
      }
    });
    compluginBabel2.default = compluginBabel2;
    module2.exports = compluginBabel2;
  }
});

// src/nuxt.ts
var import_index = __toESM(require_src());
module.exports = function(options) {
  this.extendBuild((config) => {
    const plugins = config.plugins ?? (config.plugins = []);
    plugins.unshift(import_index.default.webpack(options));
  });
  this.nuxt.hook("vite:extend", async (vite) => {
    const plugins = vite.config.plugins ?? (vite.config.plugins = []);
    plugins.push(import_index.default.vite(options));
  });
};
