var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));

// src/index.ts
import { loadPartialConfigAsync, transformAsync } from "@babel/core";
import { createComplugin, utils } from "complugin";
import { once } from "lodash";
var require_src = __commonJS({
  "src/index.ts"(exports, module) {
    var compluginBabel = createComplugin({
      name: "babel",
      enforce: void 0,
      factory(options, meta) {
        let CWD = process.cwd();
        if (meta.framework === "esbuild") {
          CWD = meta.build.initialOptions.absWorkingDir ?? CWD;
        }
        const { include: _include = [/\.(tsx?|jsx?|mjs)$/i], exclude: _exclude, cwd, ..._babelOptions } = options ?? {};
        const babelOptions = {
          ..._babelOptions,
          code: true,
          sourceMaps: true,
          compact: false,
          cwd: cwd ?? CWD
        };
        const getTransformOptions = once(async () => {
          var _a;
          return (_a = await loadPartialConfigAsync(babelOptions)) == null ? void 0 : _a.options;
        });
        return {
          transformInclude: utils.createFilter(_include, _exclude),
          async transform(code, id) {
            const transformOptions = await getTransformOptions();
            const result = await transformAsync(code, { ...transformOptions, filename: id });
            if (result) {
              const { code: code2, map } = result;
              if (code2 != null) {
                return { code: code2, map };
              }
            }
          }
        };
      }
    });
    compluginBabel.default = compluginBabel;
    module.exports = compluginBabel;
  }
});

export {
  __commonJS,
  __toESM,
  require_src
};
