import * as complugin from 'complugin';
import * as _babel_core from '@babel/core';

declare type BabelOptions = Omit<_babel_core.TransformOptions, 'fileName' | 'minify' | 'include' | 'exclude'>;
declare namespace compluginBabel {
    interface Options extends BabelOptions {
        include?: (string | RegExp)[];
        exclude?: (string | RegExp)[];
    }
}
declare const compluginBabel: complugin.CompluginInstance<compluginBabel.Options>;

export { compluginBabel as default };
